unit uSystem;

interface
uses
	Windows, Classes, SysUtils;

type
	EError = class(Exception)
	public
		class procedure Error(ModuleName: String; Message: String); overload;
		class procedure Error(ModuleName: String; fmt: String; args: array of const); overload;

        class procedure Fail;
	end;

implementation

{ TErrorException }

class procedure EError.Error(ModuleName, Message: String);
begin
	if DebugHook <> 0 then
		DebugBreak;
	raise EError.Create(ModuleName + ' : ' + Message);
end;

class procedure EError.Error(ModuleName, fmt: String;
  args: array of const);
begin
	Error(ModuleName, Format(fmt, args));
end;

class procedure EError.Fail;
begin
    Error('', 'Failed');
end;

end.
