unit uVclUtils;

interface
uses
	Windows, Classes, SysUtils, StdCtrls;

function Strings_AddHistory(Sender: TStrings; Item: String; AMaxHistoryCount: Integer = -1): TStrings;

function ComboBox_AddHistory(Sender: TCombobox; AMaxHistoryCount: Integer = 0): TComboBox;

implementation

function Strings_AddHistory(Sender: TStrings; Item: String; AMaxHistoryCount: Integer): TStrings;
var
	idx: Integer;
begin
	Result := Sender;
	Sender.BeginUpdate;
	try
		idx := Sender.IndexOf(Item);
		if idx < 0 then
		begin
			if AMaxHistoryCount >= 0 then
				while Sender.Count > AMaxHistoryCount do
					Sender.Delete(Sender.Count-1);

			Sender.Insert(0, Item);
		end
		else if idx > 0 then
			Sender.Move(idx, 0);
	finally
		Sender.EndUpdate;
	end;
end;

function ComboBox_AddHistory(Sender: TCombobox; AMaxHistoryCount: Integer): TComboBox;
begin
	Result := Sender;
	Strings_AddHistory(Sender.Items, Sender.Text, AMaxHistoryCount);
end;

end.
